/***************************************************************************
 * This program is Copyright (C) 1986, 1987, 1988 by Jonathan Payne.  JOVE *
 * is provided to you without charge, and with no warranty.  You may give  *
 * away copies of JOVE, including sources, provided that this notice is    *
 * included in all the files.                                              *
 ***************************************************************************/

/* keys.c is derived from keys.txt by setmaps */

/* Only edit keys.txt, not keys.c.
 *
 * keys.txt is processed as text by setmaps.  This means that what follows
 * is a very restricted subset of C.
 *
 * - Lines beginning with "#if", "#else", and "#endif" are understood
 *   to be the parts of conditional compilation.
 *   They will not be recognized if they are "spelled" differently
 *   (say, with whitespace).  Generally, there ought to be the same
 *   number of table entries in each branch of the if.
 *
 * - On a Mac, lines begining with "#MENU" are used to specify that
 *   the table is for a menu.
 *
 * - Lines begining with a tab followed by a " are treated as table entries.
 *
 * - Other lines are passed through, and are assumed to delimit tables.
 *   This means that they must not be within tables.
 */

#include "jove.h"
#include "commands.h"

data_obj *MainKeys[NCHARS] = {
	(data_obj *) &commands[174],	/* C-@ */
	(data_obj *) &commands[16],	/* C-A */
	(data_obj *) &commands[7],	/* C-B */
	(data_obj *) NULL,		/* C-C */
	(data_obj *) &commands[45],	/* C-D */
	(data_obj *) &commands[70],	/* C-E */
	(data_obj *) &commands[87],	/* C-F */
	(data_obj *) NULL,		/* C-G */
	(data_obj *) &commands[47],	/* C-H */
	(data_obj *) &commands[99],	/* C-I */
	(data_obj *) &commands[124],	/* C-J */
	(data_obj *) &commands[112],	/* C-K */
	(data_obj *) &commands[157],	/* C-L */
	(data_obj *) &commands[122],	/* C-M */
	(data_obj *) &commands[126],	/* C-N */
	(data_obj *) &commands[123],	/* C-O */
	(data_obj *) &commands[139],	/* C-P */
	(data_obj *) &commands[153],	/* C-Q */
	(data_obj *) &commands[169],	/* C-R */
	(data_obj *) &commands[167],	/* C-S */
	(data_obj *) &commands[192],	/* C-T */
	(data_obj *) &commands[94],	/* C-U */
	(data_obj *) &commands[127],	/* C-V */
	(data_obj *) &commands[108],	/* C-W */
	(data_obj *) NULL,		/* C-X */
	(data_obj *) &commands[205],	/* C-Y */
	(data_obj *) &commands[166],	/* C-Z */
	(data_obj *) NULL,		/* ESC */
	(data_obj *) &commands[167],	/* C-\ */
#ifndef	MSDOS
	(data_obj *) NULL,		/* C-] */
#else
	(data_obj *) &commands[85],	/* C-] */
#endif
	(data_obj *) &commands[153],	/* C-^ */
	(data_obj *) NULL,		/* C-_ */
	(data_obj *) &commands[172],	/*   */
	(data_obj *) &commands[172],	/* ! */
	(data_obj *) &commands[172],	/* " */
	(data_obj *) &commands[172],	/* # */
	(data_obj *) &commands[172],	/* $ */
	(data_obj *) &commands[172],	/* % */
	(data_obj *) &commands[172],	/* & */
	(data_obj *) &commands[172],	/* ' */
	(data_obj *) &commands[172],	/* ( */
	(data_obj *) &commands[132],	/* ) */
	(data_obj *) &commands[172],	/* * */
	(data_obj *) &commands[172],	/* + */
	(data_obj *) &commands[172],	/* , */
	(data_obj *) &commands[172],	/* - */
	(data_obj *) &commands[172],	/* . */
	(data_obj *) &commands[172],	/* / */
	(data_obj *) &commands[172],	/* 0 */
	(data_obj *) &commands[172],	/* 1 */
	(data_obj *) &commands[172],	/* 2 */
	(data_obj *) &commands[172],	/* 3 */
	(data_obj *) &commands[172],	/* 4 */
	(data_obj *) &commands[172],	/* 5 */
	(data_obj *) &commands[172],	/* 6 */
	(data_obj *) &commands[172],	/* 7 */
	(data_obj *) &commands[172],	/* 8 */
	(data_obj *) &commands[172],	/* 9 */
	(data_obj *) &commands[172],	/* : */
	(data_obj *) &commands[172],	/* ; */
	(data_obj *) &commands[172],	/* < */
	(data_obj *) &commands[172],	/* = */
	(data_obj *) &commands[172],	/* > */
	(data_obj *) &commands[172],	/* ? */
	(data_obj *) &commands[172],	/* @ */
	(data_obj *) &commands[172],	/* A */
	(data_obj *) &commands[172],	/* B */
	(data_obj *) &commands[172],	/* C */
	(data_obj *) &commands[172],	/* D */
	(data_obj *) &commands[172],	/* E */
	(data_obj *) &commands[172],	/* F */
	(data_obj *) &commands[172],	/* G */
	(data_obj *) &commands[172],	/* H */
	(data_obj *) &commands[172],	/* I */
	(data_obj *) &commands[172],	/* J */
	(data_obj *) &commands[172],	/* K */
	(data_obj *) &commands[172],	/* L */
	(data_obj *) &commands[172],	/* M */
	(data_obj *) &commands[172],	/* N */
	(data_obj *) &commands[172],	/* O */
	(data_obj *) &commands[172],	/* P */
	(data_obj *) &commands[172],	/* Q */
	(data_obj *) &commands[172],	/* R */
	(data_obj *) &commands[172],	/* S */
	(data_obj *) &commands[172],	/* T */
	(data_obj *) &commands[172],	/* U */
	(data_obj *) &commands[172],	/* V */
	(data_obj *) &commands[172],	/* W */
	(data_obj *) &commands[172],	/* X */
	(data_obj *) &commands[172],	/* Y */
	(data_obj *) &commands[172],	/* Z */
	(data_obj *) &commands[172],	/* [ */
	(data_obj *) &commands[172],	/* \ */
	(data_obj *) &commands[132],	/* ] */
	(data_obj *) &commands[172],	/* ^ */
	(data_obj *) &commands[172],	/* _ */
	(data_obj *) &commands[172],	/* ` */
	(data_obj *) &commands[172],	/* a */
	(data_obj *) &commands[172],	/* b */
	(data_obj *) &commands[172],	/* c */
	(data_obj *) &commands[172],	/* d */
	(data_obj *) &commands[172],	/* e */
	(data_obj *) &commands[172],	/* f */
	(data_obj *) &commands[172],	/* g */
	(data_obj *) &commands[172],	/* h */
	(data_obj *) &commands[172],	/* i */
	(data_obj *) &commands[172],	/* j */
	(data_obj *) &commands[172],	/* k */
	(data_obj *) &commands[172],	/* l */
	(data_obj *) &commands[172],	/* m */
	(data_obj *) &commands[172],	/* n */
	(data_obj *) &commands[172],	/* o */
	(data_obj *) &commands[172],	/* p */
	(data_obj *) &commands[172],	/* q */
	(data_obj *) &commands[172],	/* r */
	(data_obj *) &commands[172],	/* s */
	(data_obj *) &commands[172],	/* t */
	(data_obj *) &commands[172],	/* u */
	(data_obj *) &commands[172],	/* v */
	(data_obj *) &commands[172],	/* w */
	(data_obj *) &commands[172],	/* x */
	(data_obj *) &commands[172],	/* y */
	(data_obj *) &commands[172],	/* z */
	(data_obj *) &commands[172],	/* { */
	(data_obj *) &commands[172],	/* | */
	(data_obj *) &commands[132],	/* } */
	(data_obj *) &commands[172],	/* ~ */
	(data_obj *) &commands[47],	/* ^? */
#ifndef	ASCII7
	(data_obj *) &commands[172],	/* M-C-@ */
	(data_obj *) &commands[172],	/* M-C-A */
	(data_obj *) &commands[172],	/* M-C-B */
	(data_obj *) &commands[172],	/* M-C-C */
	(data_obj *) &commands[172],	/* M-C-D */
	(data_obj *) &commands[172],	/* M-C-E */
	(data_obj *) &commands[172],	/* M-C-F */
	(data_obj *) &commands[172],	/* M-C-G */
	(data_obj *) &commands[172],	/* M-C-H */
	(data_obj *) &commands[172],	/* M-C-I */
	(data_obj *) &commands[172],	/* M-C-J */
	(data_obj *) &commands[172],	/* M-C-K */
	(data_obj *) &commands[172],	/* M-C-L */
	(data_obj *) &commands[172],	/* M-C-M */
	(data_obj *) &commands[172],	/* M-C-N */
	(data_obj *) &commands[172],	/* M-C-O */
	(data_obj *) &commands[172],	/* M-C-P */
	(data_obj *) &commands[172],	/* M-C-Q */
	(data_obj *) &commands[172],	/* M-C-R */
	(data_obj *) &commands[172],	/* M-C-S */
	(data_obj *) &commands[172],	/* M-C-T */
	(data_obj *) &commands[172],	/* M-C-U */
	(data_obj *) &commands[172],	/* M-C-V */
	(data_obj *) &commands[172],	/* M-C-W */
	(data_obj *) &commands[172],	/* M-C-X */
	(data_obj *) &commands[172],	/* M-C-Y */
	(data_obj *) &commands[172],	/* M-C-Z */
	(data_obj *) &commands[172],	/* M-ESC */
	(data_obj *) &commands[172],	/* M-C-\ */
	(data_obj *) &commands[172],	/* M-C-] */
	(data_obj *) &commands[172],	/* M-C-^ */
	(data_obj *) &commands[172],	/* M-C-_ */
	(data_obj *) &commands[172],	/* M-  */
	(data_obj *) &commands[172],	/* M-! */
	(data_obj *) &commands[172],	/* M-" */
	(data_obj *) &commands[172],	/* M-# */
	(data_obj *) &commands[172],	/* M-$ */
	(data_obj *) &commands[172],	/* M-% */
	(data_obj *) &commands[172],	/* M-& */
	(data_obj *) &commands[172],	/* M-' */
	(data_obj *) &commands[172],	/* M-( */
	(data_obj *) &commands[172],	/* M-) */
	(data_obj *) &commands[172],	/* M-* */
	(data_obj *) &commands[172],	/* M-+ */
	(data_obj *) &commands[172],	/* M-, */
	(data_obj *) &commands[172],	/* M-- */
	(data_obj *) &commands[172],	/* M-. */
	(data_obj *) &commands[172],	/* M-/ */
	(data_obj *) &commands[172],	/* M-0 */
	(data_obj *) &commands[172],	/* M-1 */
	(data_obj *) &commands[172],	/* M-2 */
	(data_obj *) &commands[172],	/* M-3 */
	(data_obj *) &commands[172],	/* M-4 */
	(data_obj *) &commands[172],	/* M-5 */
	(data_obj *) &commands[172],	/* M-6 */
	(data_obj *) &commands[172],	/* M-7 */
	(data_obj *) &commands[172],	/* M-8 */
	(data_obj *) &commands[172],	/* M-9 */
	(data_obj *) &commands[172],	/* M-: */
	(data_obj *) &commands[172],	/* M-; */
	(data_obj *) &commands[172],	/* M-< */
	(data_obj *) &commands[172],	/* M-= */
	(data_obj *) &commands[172],	/* M-> */
	(data_obj *) &commands[172],	/* M-? */
	(data_obj *) &commands[172],	/* M-@ */
	(data_obj *) &commands[172],	/* M-A */
	(data_obj *) &commands[172],	/* M-B */
	(data_obj *) &commands[172],	/* M-C */
	(data_obj *) &commands[172],	/* M-D */
	(data_obj *) &commands[172],	/* M-E */
	(data_obj *) &commands[172],	/* M-F */
	(data_obj *) &commands[172],	/* M-G */
	(data_obj *) &commands[172],	/* M-H */
	(data_obj *) &commands[172],	/* M-I */
	(data_obj *) &commands[172],	/* M-J */
	(data_obj *) &commands[172],	/* M-K */
	(data_obj *) &commands[172],	/* M-L */
	(data_obj *) &commands[172],	/* M-M */
	(data_obj *) &commands[172],	/* M-N */
	(data_obj *) &commands[172],	/* M-O */
	(data_obj *) &commands[172],	/* M-P */
	(data_obj *) &commands[172],	/* M-Q */
	(data_obj *) &commands[172],	/* M-R */
	(data_obj *) &commands[172],	/* M-S */
	(data_obj *) &commands[172],	/* M-T */
	(data_obj *) &commands[172],	/* M-U */
	(data_obj *) &commands[172],	/* M-V */
	(data_obj *) &commands[172],	/* M-W */
	(data_obj *) &commands[172],	/* M-X */
	(data_obj *) &commands[172],	/* M-Y */
	(data_obj *) &commands[172],	/* M-Z */
	(data_obj *) &commands[172],	/* M-[ */
	(data_obj *) &commands[172],	/* M-\ */
	(data_obj *) &commands[172],	/* M-] */
	(data_obj *) &commands[172],	/* M-^ */
	(data_obj *) &commands[172],	/* M-_ */
	(data_obj *) &commands[172],	/* M-` */
	(data_obj *) &commands[172],	/* M-a */
	(data_obj *) &commands[172],	/* M-b */
	(data_obj *) &commands[172],	/* M-c */
	(data_obj *) &commands[172],	/* M-d */
	(data_obj *) &commands[172],	/* M-e */
	(data_obj *) &commands[172],	/* M-f */
	(data_obj *) &commands[172],	/* M-g */
	(data_obj *) &commands[172],	/* M-h */
	(data_obj *) &commands[172],	/* M-i */
	(data_obj *) &commands[172],	/* M-j */
	(data_obj *) &commands[172],	/* M-k */
	(data_obj *) &commands[172],	/* M-l */
	(data_obj *) &commands[172],	/* M-m */
	(data_obj *) &commands[172],	/* M-n */
	(data_obj *) &commands[172],	/* M-o */
	(data_obj *) &commands[172],	/* M-p */
	(data_obj *) &commands[172],	/* M-q */
	(data_obj *) &commands[172],	/* M-r */
	(data_obj *) &commands[172],	/* M-s */
	(data_obj *) &commands[172],	/* M-t */
	(data_obj *) &commands[172],	/* M-u */
	(data_obj *) &commands[172],	/* M-v */
	(data_obj *) &commands[172],	/* M-w */
	(data_obj *) &commands[172],	/* M-x */
	(data_obj *) &commands[172],	/* M-y */
	(data_obj *) &commands[172],	/* M-z */
	(data_obj *) &commands[172],	/* M-{ */
	(data_obj *) &commands[172],	/* M-| */
	(data_obj *) &commands[172],	/* M-} */
	(data_obj *) &commands[172],	/* M-~ */
#ifdef	IBMPC
	(data_obj *) NULL,		/* M-^? */
#else
	(data_obj *) &commands[172],	/* M-^? */
#endif
#endif	/* !ASCII7 */
};

data_obj *EscKeys[NCHARS] = {
	(data_obj *) &commands[174],	/* C-@ */
	(data_obj *) NULL,		/* C-A */
	(data_obj *) &commands[10],	/* C-B */
	(data_obj *) NULL,		/* C-C */
	(data_obj *) &commands[65],	/* C-D */
	(data_obj *) NULL,		/* C-E */
	(data_obj *) &commands[90],	/* C-F */
	(data_obj *) NULL,		/* C-G */
	(data_obj *) NULL,		/* C-H */
	(data_obj *) NULL,		/* C-I */
	(data_obj *) NULL,		/* C-J */
	(data_obj *) &commands[109],	/* C-K */
	(data_obj *) &commands[32],	/* C-L */
	(data_obj *) NULL,		/* C-M */
	(data_obj *) &commands[88],	/* C-N */
	(data_obj *) NULL,		/* C-O */
	(data_obj *) &commands[8],	/* C-P */
	(data_obj *) NULL,		/* C-Q */
	(data_obj *) NULL,		/* C-R */
	(data_obj *) NULL,		/* C-S */
	(data_obj *) NULL,		/* C-T */
	(data_obj *) &commands[12],	/* C-U */
	(data_obj *) &commands[131],	/* C-V */
	(data_obj *) NULL,		/* C-W */
	(data_obj *) NULL,		/* C-X */
	(data_obj *) NULL,		/* C-Y */
	(data_obj *) NULL,		/* C-Z */
	(data_obj *) NULL,		/* ESC */
	(data_obj *) NULL,		/* C-\ */
	(data_obj *) NULL,		/* C-] */
	(data_obj *) NULL,		/* C-^ */
	(data_obj *) NULL,		/* C-_ */
	(data_obj *) NULL,		/*   */
	(data_obj *) NULL,		/* ! */
	(data_obj *) NULL,		/* " */
	(data_obj *) NULL,		/* # */
	(data_obj *) NULL,		/* $ */
	(data_obj *) NULL,		/* % */
	(data_obj *) NULL,		/* & */
	(data_obj *) NULL,		/* ' */
	(data_obj *) NULL,		/* ( */
	(data_obj *) NULL,		/* ) */
	(data_obj *) NULL,		/* * */
	(data_obj *) NULL,		/* + */
	(data_obj *) &commands[17],	/* , */
	(data_obj *) &commands[63],	/* - */
	(data_obj *) &commands[71],	/* . */
	(data_obj *) NULL,		/* / */
	(data_obj *) &commands[53],	/* 0 */
	(data_obj *) &commands[54],	/* 1 */
	(data_obj *) &commands[55],	/* 2 */
	(data_obj *) &commands[56],	/* 3 */
	(data_obj *) &commands[57],	/* 4 */
	(data_obj *) &commands[58],	/* 5 */
	(data_obj *) &commands[59],	/* 6 */
	(data_obj *) &commands[60],	/* 7 */
	(data_obj *) &commands[61],	/* 8 */
	(data_obj *) &commands[62],	/* 9 */
	(data_obj *) NULL,		/* : */
	(data_obj *) NULL,		/* ; */
	(data_obj *) &commands[15],	/* < */
	(data_obj *) NULL,		/* = */
	(data_obj *) &commands[69],	/* > */
	(data_obj *) &commands[50],	/* ? */
	(data_obj *) NULL,		/* @ */
	(data_obj *) &commands[11],	/* A */
	(data_obj *) &commands[13],	/* B */
	(data_obj *) &commands[27],	/* C */
	(data_obj *) &commands[105],	/* D */
	(data_obj *) &commands[91],	/* E */
	(data_obj *) &commands[92],	/* F */
	(data_obj *) &commands[95],	/* G */
	(data_obj *) NULL,		/* H */
	(data_obj *) &commands[120],	/* I */
	(data_obj *) &commands[80],	/* J */
	(data_obj *) &commands[113],	/* K */
	(data_obj *) &commands[28],	/* L */
	(data_obj *) &commands[86],	/* M */
	(data_obj *) NULL,		/* N */
	(data_obj *) NULL,		/* O */
	(data_obj *) NULL,		/* P */
	(data_obj *) &commands[151],	/* Q */
	(data_obj *) &commands[160],	/* R */
	(data_obj *) NULL,		/* S */
	(data_obj *) NULL,		/* T */
	(data_obj *) &commands[29],	/* U */
	(data_obj *) &commands[140],	/* V */
	(data_obj *) &commands[35],	/* W */
	(data_obj *) &commands[77],	/* X */
	(data_obj *) &commands[206],	/* Y */
	(data_obj *) &commands[163],	/* Z */
	(data_obj *) &commands[9],	/* [ */
	(data_obj *) &commands[48],	/* \ */
	(data_obj *) &commands[89],	/* ] */
	(data_obj *) NULL,		/* ^ */
	(data_obj *) NULL,		/* _ */
	(data_obj *) NULL,		/* ` */
	(data_obj *) &commands[11],	/* a */
	(data_obj *) &commands[13],	/* b */
	(data_obj *) &commands[27],	/* c */
	(data_obj *) &commands[105],	/* d */
	(data_obj *) &commands[91],	/* e */
	(data_obj *) &commands[92],	/* f */
	(data_obj *) &commands[95],	/* g */
	(data_obj *) NULL,		/* h */
	(data_obj *) &commands[120],	/* i */
	(data_obj *) &commands[80],	/* j */
	(data_obj *) &commands[113],	/* k */
	(data_obj *) &commands[28],	/* l */
	(data_obj *) &commands[86],	/* m */
	(data_obj *) NULL,		/* n */
	(data_obj *) NULL,		/* o */
	(data_obj *) NULL,		/* p */
	(data_obj *) &commands[151],	/* q */
	(data_obj *) &commands[160],	/* r */
	(data_obj *) NULL,		/* s */
	(data_obj *) NULL,		/* t */
	(data_obj *) &commands[29],	/* u */
	(data_obj *) &commands[140],	/* v */
	(data_obj *) &commands[35],	/* w */
	(data_obj *) &commands[77],	/* x */
	(data_obj *) &commands[206],	/* y */
	(data_obj *) &commands[163],	/* z */
	(data_obj *) NULL,		/* { */
	(data_obj *) NULL,		/* | */
	(data_obj *) NULL,		/* } */
	(data_obj *) &commands[118],	/* ~ */
	(data_obj *) &commands[106],	/* ^? */
#ifndef	ASCII7
	(data_obj *) NULL,		/* M-C-@ */
	(data_obj *) NULL,		/* M-C-A */
	(data_obj *) NULL,		/* M-C-B */
	(data_obj *) NULL,		/* M-C-C */
	(data_obj *) NULL,		/* M-C-D */
	(data_obj *) NULL,		/* M-C-E */
	(data_obj *) NULL,		/* M-C-F */
	(data_obj *) NULL,		/* M-C-G */
	(data_obj *) NULL,		/* M-C-H */
	(data_obj *) NULL,		/* M-C-I */
	(data_obj *) NULL,		/* M-C-J */
	(data_obj *) NULL,		/* M-C-K */
	(data_obj *) NULL,		/* M-C-L */
	(data_obj *) NULL,		/* M-C-M */
	(data_obj *) NULL,		/* M-C-N */
	(data_obj *) NULL,		/* M-C-O */
	(data_obj *) NULL,		/* M-C-P */
	(data_obj *) NULL,		/* M-C-Q */
	(data_obj *) NULL,		/* M-C-R */
	(data_obj *) NULL,		/* M-C-S */
	(data_obj *) NULL,		/* M-C-T */
	(data_obj *) NULL,		/* M-C-U */
	(data_obj *) NULL,		/* M-C-V */
	(data_obj *) NULL,		/* M-C-W */
	(data_obj *) NULL,		/* M-C-X */
	(data_obj *) NULL,		/* M-C-Y */
	(data_obj *) NULL,		/* M-C-Z */
	(data_obj *) NULL,		/* M-ESC */
	(data_obj *) NULL,		/* M-C-\ */
	(data_obj *) NULL,		/* M-C-] */
	(data_obj *) NULL,		/* M-C-^ */
	(data_obj *) NULL,		/* M-C-_ */
	(data_obj *) NULL,		/* M-  */
	(data_obj *) NULL,		/* M-! */
	(data_obj *) NULL,		/* M-" */
	(data_obj *) NULL,		/* M-# */
	(data_obj *) NULL,		/* M-$ */
	(data_obj *) NULL,		/* M-% */
	(data_obj *) NULL,		/* M-& */
	(data_obj *) NULL,		/* M-' */
	(data_obj *) NULL,		/* M-( */
	(data_obj *) NULL,		/* M-) */
	(data_obj *) NULL,		/* M-* */
	(data_obj *) NULL,		/* M-+ */
	(data_obj *) NULL,		/* M-, */
	(data_obj *) NULL,		/* M-- */
	(data_obj *) NULL,		/* M-. */
	(data_obj *) NULL,		/* M-/ */
	(data_obj *) NULL,		/* M-0 */
	(data_obj *) NULL,		/* M-1 */
	(data_obj *) NULL,		/* M-2 */
	(data_obj *) NULL,		/* M-3 */
	(data_obj *) NULL,		/* M-4 */
	(data_obj *) NULL,		/* M-5 */
	(data_obj *) NULL,		/* M-6 */
	(data_obj *) NULL,		/* M-7 */
	(data_obj *) NULL,		/* M-8 */
	(data_obj *) NULL,		/* M-9 */
	(data_obj *) NULL,		/* M-: */
	(data_obj *) NULL,		/* M-; */
	(data_obj *) NULL,		/* M-< */
	(data_obj *) NULL,		/* M-= */
	(data_obj *) NULL,		/* M-> */
	(data_obj *) NULL,		/* M-? */
	(data_obj *) NULL,		/* M-@ */
	(data_obj *) NULL,		/* M-A */
	(data_obj *) NULL,		/* M-B */
	(data_obj *) NULL,		/* M-C */
	(data_obj *) NULL,		/* M-D */
	(data_obj *) NULL,		/* M-E */
	(data_obj *) NULL,		/* M-F */
	(data_obj *) NULL,		/* M-G */
	(data_obj *) NULL,		/* M-H */
	(data_obj *) NULL,		/* M-I */
	(data_obj *) NULL,		/* M-J */
	(data_obj *) NULL,		/* M-K */
	(data_obj *) NULL,		/* M-L */
	(data_obj *) NULL,		/* M-M */
	(data_obj *) NULL,		/* M-N */
	(data_obj *) NULL,		/* M-O */
	(data_obj *) NULL,		/* M-P */
	(data_obj *) NULL,		/* M-Q */
	(data_obj *) NULL,		/* M-R */
	(data_obj *) NULL,		/* M-S */
	(data_obj *) NULL,		/* M-T */
	(data_obj *) NULL,		/* M-U */
	(data_obj *) NULL,		/* M-V */
	(data_obj *) NULL,		/* M-W */
	(data_obj *) NULL,		/* M-X */
	(data_obj *) NULL,		/* M-Y */
	(data_obj *) NULL,		/* M-Z */
	(data_obj *) NULL,		/* M-[ */
	(data_obj *) NULL,		/* M-\ */
	(data_obj *) NULL,		/* M-] */
	(data_obj *) NULL,		/* M-^ */
	(data_obj *) NULL,		/* M-_ */
	(data_obj *) NULL,		/* M-` */
	(data_obj *) NULL,		/* M-a */
	(data_obj *) NULL,		/* M-b */
	(data_obj *) NULL,		/* M-c */
	(data_obj *) NULL,		/* M-d */
	(data_obj *) NULL,		/* M-e */
	(data_obj *) NULL,		/* M-f */
	(data_obj *) NULL,		/* M-g */
	(data_obj *) NULL,		/* M-h */
	(data_obj *) NULL,		/* M-i */
	(data_obj *) NULL,		/* M-j */
	(data_obj *) NULL,		/* M-k */
	(data_obj *) NULL,		/* M-l */
	(data_obj *) NULL,		/* M-m */
	(data_obj *) NULL,		/* M-n */
	(data_obj *) NULL,		/* M-o */
	(data_obj *) NULL,		/* M-p */
	(data_obj *) NULL,		/* M-q */
	(data_obj *) NULL,		/* M-r */
	(data_obj *) NULL,		/* M-s */
	(data_obj *) NULL,		/* M-t */
	(data_obj *) NULL,		/* M-u */
	(data_obj *) NULL,		/* M-v */
	(data_obj *) NULL,		/* M-w */
	(data_obj *) NULL,		/* M-x */
	(data_obj *) NULL,		/* M-y */
	(data_obj *) NULL,		/* M-z */
	(data_obj *) NULL,		/* M-{ */
	(data_obj *) NULL,		/* M-| */
	(data_obj *) NULL,		/* M-} */
	(data_obj *) NULL,		/* M-~ */
	(data_obj *) NULL,		/* M-^? */
#endif	/* !ASCII7 */
};

data_obj	*CtlxKeys[NCHARS] = {
	(data_obj *) NULL,		/* C-@ */
	(data_obj *) NULL,		/* C-A */
	(data_obj *) &commands[116],	/* C-B */
	(data_obj *) &commands[78],	/* C-C */
	(data_obj *) NULL,		/* C-D */
	(data_obj *) &commands[33],	/* C-E */
	(data_obj *) &commands[83],	/* C-F */
	(data_obj *) NULL,		/* C-G */
	(data_obj *) NULL,		/* C-H */
	(data_obj *) &commands[103],	/* C-I */
	(data_obj *) NULL,		/* C-J */
	(data_obj *) NULL,		/* C-K */
	(data_obj *) NULL,		/* C-L */
	(data_obj *) &commands[202],	/* C-M */
	(data_obj *) &commands[125],	/* C-N */
	(data_obj *) &commands[41],	/* C-O */
	(data_obj *) &commands[138],	/* C-P */
	(data_obj *) NULL,		/* C-Q */
	(data_obj *) &commands[197],	/* C-R */
	(data_obj *) &commands[162],	/* C-S */
	(data_obj *) &commands[193],	/* C-T */
	(data_obj *) NULL,		/* C-U */
	(data_obj *) &commands[197],	/* C-V */
	(data_obj *) &commands[200],	/* C-W */
	(data_obj *) &commands[74],	/* C-X */
	(data_obj *) NULL,		/* C-Y */
	(data_obj *) NULL,		/* C-Z */
	(data_obj *) NULL,		/* ESC */
	(data_obj *) &commands[162],	/* C-\ */
	(data_obj *) NULL,		/* C-] */
	(data_obj *) NULL,		/* C-^ */
	(data_obj *) NULL,		/* C-_ */
	(data_obj *) NULL,		/*   */
	(data_obj *) &commands[176],	/* ! */
	(data_obj *) NULL,		/* " */
	(data_obj *) NULL,		/* # */
	(data_obj *) NULL,		/* $ */
	(data_obj *) NULL,		/* % */
	(data_obj *) NULL,		/* & */
	(data_obj *) NULL,		/* ' */
	(data_obj *) &commands[14],	/* ( */
	(data_obj *) &commands[68],	/* ) */
	(data_obj *) NULL,		/* * */
	(data_obj *) NULL,		/* + */
	(data_obj *) NULL,		/* , */
	(data_obj *) NULL,		/* - */
	(data_obj *) NULL,		/* . */
	(data_obj *) NULL,		/* / */
	(data_obj *) NULL,		/* 0 */
	(data_obj *) &commands[46],	/* 1 */
	(data_obj *) &commands[186],	/* 2 */
	(data_obj *) NULL,		/* 3 */
	(data_obj *) &commands[198],	/* 4 */
	(data_obj *) NULL,		/* 5 */
	(data_obj *) NULL,		/* 6 */
	(data_obj *) NULL,		/* 7 */
	(data_obj *) NULL,		/* 8 */
	(data_obj *) NULL,		/* 9 */
	(data_obj *) NULL,		/* : */
	(data_obj *) NULL,		/* ; */
	(data_obj *) NULL,		/* < */
	(data_obj *) NULL,		/* = */
	(data_obj *) NULL,		/* > */
	(data_obj *) &commands[51],	/* ? */
	(data_obj *) NULL,		/* @ */
	(data_obj *) NULL,		/* A */
	(data_obj *) &commands[171],	/* B */
	(data_obj *) NULL,		/* C */
	(data_obj *) &commands[43],	/* D */
	(data_obj *) &commands[75],	/* E */
	(data_obj *) NULL,		/* F */
	(data_obj *) NULL,		/* G */
	(data_obj *) NULL,		/* H */
	(data_obj *) NULL,		/* I */
	(data_obj *) NULL,		/* J */
	(data_obj *) &commands[42],	/* K */
	(data_obj *) NULL,		/* L */
	(data_obj *) NULL,		/* M */
	(data_obj *) &commands[128],	/* N */
	(data_obj *) &commands[141],	/* O */
	(data_obj *) &commands[141],	/* P */
	(data_obj *) NULL,		/* Q */
	(data_obj *) NULL,		/* R */
	(data_obj *) &commands[162],	/* S */
	(data_obj *) &commands[84],	/* T */
	(data_obj *) NULL,		/* U */
	(data_obj *) NULL,		/* V */
	(data_obj *) NULL,		/* W */
	(data_obj *) NULL,		/* X */
	(data_obj *) NULL,		/* Y */
	(data_obj *) NULL,		/* Z */
	(data_obj *) NULL,		/* [ */
	(data_obj *) NULL,		/* \ */
	(data_obj *) NULL,		/* ] */
	(data_obj *) &commands[98],	/* ^ */
	(data_obj *) NULL,		/* _ */
	(data_obj *) NULL,		/* ` */
	(data_obj *) NULL,		/* a */
	(data_obj *) &commands[171],	/* b */
	(data_obj *) NULL,		/* c */
	(data_obj *) &commands[43],	/* d */
	(data_obj *) &commands[75],	/* e */
	(data_obj *) NULL,		/* f */
	(data_obj *) NULL,		/* g */
	(data_obj *) NULL,		/* h */
	(data_obj *) NULL,		/* i */
	(data_obj *) NULL,		/* j */
	(data_obj *) &commands[42],	/* k */
	(data_obj *) NULL,		/* l */
	(data_obj *) NULL,		/* m */
	(data_obj *) &commands[128],	/* n */
	(data_obj *) &commands[141],	/* o */
	(data_obj *) &commands[141],	/* p */
	(data_obj *) NULL,		/* q */
	(data_obj *) NULL,		/* r */
	(data_obj *) &commands[162],	/* s */
	(data_obj *) &commands[84],	/* t */
	(data_obj *) NULL,		/* u */
	(data_obj *) NULL,		/* v */
	(data_obj *) NULL,		/* w */
	(data_obj *) NULL,		/* x */
	(data_obj *) NULL,		/* y */
	(data_obj *) NULL,		/* z */
	(data_obj *) NULL,		/* { */
	(data_obj *) NULL,		/* | */
	(data_obj *) NULL,		/* } */
	(data_obj *) NULL,		/* ~ */
	(data_obj *) &commands[111],	/* ^? */
#ifndef	ASCII7
	(data_obj *) NULL,		/* M-C-@ */
	(data_obj *) NULL,		/* M-C-A */
	(data_obj *) NULL,		/* M-C-B */
	(data_obj *) NULL,		/* M-C-C */
	(data_obj *) NULL,		/* M-C-D */
	(data_obj *) NULL,		/* M-C-E */
	(data_obj *) NULL,		/* M-C-F */
	(data_obj *) NULL,		/* M-C-G */
	(data_obj *) NULL,		/* M-C-H */
	(data_obj *) NULL,		/* M-C-I */
	(data_obj *) NULL,		/* M-C-J */
	(data_obj *) NULL,		/* M-C-K */
	(data_obj *) NULL,		/* M-C-L */
	(data_obj *) NULL,		/* M-C-M */
	(data_obj *) NULL,		/* M-C-N */
	(data_obj *) NULL,		/* M-C-O */
	(data_obj *) NULL,		/* M-C-P */
	(data_obj *) NULL,		/* M-C-Q */
	(data_obj *) NULL,		/* M-C-R */
	(data_obj *) NULL,		/* M-C-S */
	(data_obj *) NULL,		/* M-C-T */
	(data_obj *) NULL,		/* M-C-U */
	(data_obj *) NULL,		/* M-C-V */
	(data_obj *) NULL,		/* M-C-W */
	(data_obj *) NULL,		/* M-C-X */
	(data_obj *) NULL,		/* M-C-Y */
	(data_obj *) NULL,		/* M-C-Z */
	(data_obj *) NULL,		/* M-ESC */
	(data_obj *) NULL,		/* M-C-\ */
	(data_obj *) NULL,		/* M-C-] */
	(data_obj *) NULL,		/* M-C-^ */
	(data_obj *) NULL,		/* M-C-_ */
	(data_obj *) NULL,		/* M-  */
	(data_obj *) NULL,		/* M-! */
	(data_obj *) NULL,		/* M-" */
	(data_obj *) NULL,		/* M-# */
	(data_obj *) NULL,		/* M-$ */
	(data_obj *) NULL,		/* M-% */
	(data_obj *) NULL,		/* M-& */
	(data_obj *) NULL,		/* M-' */
	(data_obj *) NULL,		/* M-( */
	(data_obj *) NULL,		/* M-) */
	(data_obj *) NULL,		/* M-* */
	(data_obj *) NULL,		/* M-+ */
	(data_obj *) NULL,		/* M-, */
	(data_obj *) NULL,		/* M-- */
	(data_obj *) NULL,		/* M-. */
	(data_obj *) NULL,		/* M-/ */
	(data_obj *) NULL,		/* M-0 */
	(data_obj *) NULL,		/* M-1 */
	(data_obj *) NULL,		/* M-2 */
	(data_obj *) NULL,		/* M-3 */
	(data_obj *) NULL,		/* M-4 */
	(data_obj *) NULL,		/* M-5 */
	(data_obj *) NULL,		/* M-6 */
	(data_obj *) NULL,		/* M-7 */
	(data_obj *) NULL,		/* M-8 */
	(data_obj *) NULL,		/* M-9 */
	(data_obj *) NULL,		/* M-: */
	(data_obj *) NULL,		/* M-; */
	(data_obj *) NULL,		/* M-< */
	(data_obj *) NULL,		/* M-= */
	(data_obj *) NULL,		/* M-> */
	(data_obj *) NULL,		/* M-? */
	(data_obj *) NULL,		/* M-@ */
	(data_obj *) NULL,		/* M-A */
	(data_obj *) NULL,		/* M-B */
	(data_obj *) NULL,		/* M-C */
	(data_obj *) NULL,		/* M-D */
	(data_obj *) NULL,		/* M-E */
	(data_obj *) NULL,		/* M-F */
	(data_obj *) NULL,		/* M-G */
	(data_obj *) NULL,		/* M-H */
	(data_obj *) NULL,		/* M-I */
	(data_obj *) NULL,		/* M-J */
	(data_obj *) NULL,		/* M-K */
	(data_obj *) NULL,		/* M-L */
	(data_obj *) NULL,		/* M-M */
	(data_obj *) NULL,		/* M-N */
	(data_obj *) NULL,		/* M-O */
	(data_obj *) NULL,		/* M-P */
	(data_obj *) NULL,		/* M-Q */
	(data_obj *) NULL,		/* M-R */
	(data_obj *) NULL,		/* M-S */
	(data_obj *) NULL,		/* M-T */
	(data_obj *) NULL,		/* M-U */
	(data_obj *) NULL,		/* M-V */
	(data_obj *) NULL,		/* M-W */
	(data_obj *) NULL,		/* M-X */
	(data_obj *) NULL,		/* M-Y */
	(data_obj *) NULL,		/* M-Z */
	(data_obj *) NULL,		/* M-[ */
	(data_obj *) NULL,		/* M-\ */
	(data_obj *) NULL,		/* M-] */
	(data_obj *) NULL,		/* M-^ */
	(data_obj *) NULL,		/* M-_ */
	(data_obj *) NULL,		/* M-` */
	(data_obj *) NULL,		/* M-a */
	(data_obj *) NULL,		/* M-b */
	(data_obj *) NULL,		/* M-c */
	(data_obj *) NULL,		/* M-d */
	(data_obj *) NULL,		/* M-e */
	(data_obj *) NULL,		/* M-f */
	(data_obj *) NULL,		/* M-g */
	(data_obj *) NULL,		/* M-h */
	(data_obj *) NULL,		/* M-i */
	(data_obj *) NULL,		/* M-j */
	(data_obj *) NULL,		/* M-k */
	(data_obj *) NULL,		/* M-l */
	(data_obj *) NULL,		/* M-m */
	(data_obj *) NULL,		/* M-n */
	(data_obj *) NULL,		/* M-o */
	(data_obj *) NULL,		/* M-p */
	(data_obj *) NULL,		/* M-q */
	(data_obj *) NULL,		/* M-r */
	(data_obj *) NULL,		/* M-s */
	(data_obj *) NULL,		/* M-t */
	(data_obj *) NULL,		/* M-u */
	(data_obj *) NULL,		/* M-v */
	(data_obj *) NULL,		/* M-w */
	(data_obj *) NULL,		/* M-x */
	(data_obj *) NULL,		/* M-y */
	(data_obj *) NULL,		/* M-z */
	(data_obj *) NULL,		/* M-{ */
	(data_obj *) NULL,		/* M-| */
	(data_obj *) NULL,		/* M-} */
	(data_obj *) NULL,		/* M-~ */
	(data_obj *) NULL,		/* M-^? */
#endif	/* !ASCII7 */
};

#ifdef IBMPC
data_obj	*NonASCIIKeys[NCHARS] = {
	(data_obj *) NULL,		/* C-@ */
	(data_obj *) NULL,		/* C-A */
	(data_obj *) NULL,		/* C-B */
	(data_obj *) &commands[174],	/* C-C */
	(data_obj *) NULL,		/* C-D */
	(data_obj *) NULL,		/* C-E */
	(data_obj *) NULL,		/* C-F */
	(data_obj *) NULL,		/* C-G */
	(data_obj *) NULL,		/* C-H */
	(data_obj *) NULL,		/* C-I */
	(data_obj *) NULL,		/* C-J */
	(data_obj *) NULL,		/* C-K */
	(data_obj *) NULL,		/* C-L */
	(data_obj *) NULL,		/* C-M */
	(data_obj *) NULL,		/* C-N */
	(data_obj *) NULL,		/* C-O */
	(data_obj *) &commands[151],	/* C-P */
	(data_obj *) &commands[35],	/* C-Q */
	(data_obj *) &commands[91],	/* C-R */
	(data_obj *) &commands[160],	/* C-S */
	(data_obj *) NULL,		/* C-T */
	(data_obj *) &commands[206],	/* C-U */
	(data_obj *) &commands[29],	/* C-V */
	(data_obj *) &commands[120],	/* C-W */
	(data_obj *) NULL,		/* C-X */
	(data_obj *) NULL,		/* C-Y */
	(data_obj *) NULL,		/* C-Z */
	(data_obj *) NULL,		/* ESC */
	(data_obj *) NULL,		/* C-\ */
	(data_obj *) NULL,		/* C-] */
	(data_obj *) &commands[11],	/* C-^ */
	(data_obj *) NULL,		/* C-_ */
	(data_obj *) &commands[105],	/*   */
	(data_obj *) &commands[92],	/* ! */
	(data_obj *) &commands[95],	/* " */
	(data_obj *) NULL,		/* # */
	(data_obj *) &commands[80],	/* $ */
	(data_obj *) &commands[113],	/* % */
	(data_obj *) &commands[28],	/* & */
	(data_obj *) NULL,		/* ' */
	(data_obj *) NULL,		/* ( */
	(data_obj *) NULL,		/* ) */
	(data_obj *) NULL,		/* * */
	(data_obj *) NULL,		/* + */
	(data_obj *) &commands[163],	/* , */
	(data_obj *) &commands[77],	/* - */
	(data_obj *) &commands[27],	/* . */
	(data_obj *) &commands[140],	/* / */
	(data_obj *) &commands[13],	/* 0 */
	(data_obj *) NULL,		/* 1 */
	(data_obj *) &commands[86],	/* 2 */
	(data_obj *) NULL,		/* 3 */
	(data_obj *) NULL,		/* 4 */
	(data_obj *) NULL,		/* 5 */
	(data_obj *) NULL,		/* 6 */
	(data_obj *) NULL,		/* 7 */
	(data_obj *) NULL,		/* 8 */
	(data_obj *) NULL,		/* 9 */
	(data_obj *) NULL,		/* : */
	(data_obj *) NULL,		/* ; */
	(data_obj *) NULL,		/* < */
	(data_obj *) NULL,		/* = */
	(data_obj *) NULL,		/* > */
	(data_obj *) NULL,		/* ? */
	(data_obj *) NULL,		/* @ */
	(data_obj *) NULL,		/* A */
	(data_obj *) NULL,		/* B */
	(data_obj *) NULL,		/* C */
	(data_obj *) NULL,		/* D */
	(data_obj *) NULL,		/* E */
	(data_obj *) NULL,		/* F */
	(data_obj *) &commands[16],	/* G */
	(data_obj *) &commands[139],	/* H */
	(data_obj *) &commands[140],	/* I */
	(data_obj *) NULL,		/* J */
	(data_obj *) &commands[7],	/* K */
	(data_obj *) NULL,		/* L */
	(data_obj *) &commands[87],	/* M */
	(data_obj *) NULL,		/* N */
	(data_obj *) &commands[70],	/* O */
	(data_obj *) &commands[126],	/* P */
	(data_obj *) &commands[127],	/* Q */
	(data_obj *) &commands[130],	/* R */
	(data_obj *) &commands[45],	/* S */
	(data_obj *) NULL,		/* T */
	(data_obj *) NULL,		/* U */
	(data_obj *) NULL,		/* V */
	(data_obj *) NULL,		/* W */
	(data_obj *) NULL,		/* X */
	(data_obj *) NULL,		/* Y */
	(data_obj *) NULL,		/* Z */
	(data_obj *) NULL,		/* [ */
	(data_obj *) NULL,		/* \ */
	(data_obj *) NULL,		/* ] */
	(data_obj *) NULL,		/* ^ */
	(data_obj *) NULL,		/* _ */
	(data_obj *) NULL,		/* ` */
	(data_obj *) NULL,		/* a */
	(data_obj *) NULL,		/* b */
	(data_obj *) NULL,		/* c */
	(data_obj *) NULL,		/* d */
	(data_obj *) NULL,		/* e */
	(data_obj *) NULL,		/* f */
	(data_obj *) NULL,		/* g */
	(data_obj *) NULL,		/* h */
	(data_obj *) NULL,		/* i */
	(data_obj *) NULL,		/* j */
	(data_obj *) NULL,		/* k */
	(data_obj *) NULL,		/* l */
	(data_obj *) NULL,		/* m */
	(data_obj *) NULL,		/* n */
	(data_obj *) NULL,		/* o */
	(data_obj *) NULL,		/* p */
	(data_obj *) NULL,		/* q */
	(data_obj *) NULL,		/* r */
	(data_obj *) &commands[13],	/* s */
	(data_obj *) &commands[92],	/* t */
	(data_obj *) &commands[69],	/* u */
	(data_obj *) &commands[128],	/* v */
	(data_obj *) &commands[15],	/* w */
	(data_obj *) NULL,		/* x */
	(data_obj *) NULL,		/* y */
	(data_obj *) NULL,		/* z */
	(data_obj *) NULL,		/* { */
	(data_obj *) NULL,		/* | */
	(data_obj *) NULL,		/* } */
	(data_obj *) NULL,		/* ~ */
	(data_obj *) NULL,		/* ^? */
	(data_obj *) NULL,		/* M-C-@ */
	(data_obj *) NULL,		/* M-C-A */
	(data_obj *) NULL,		/* M-C-B */
	(data_obj *) NULL,		/* M-C-C */
	(data_obj *) &commands[141],	/* M-C-D */
	(data_obj *) NULL,		/* M-C-E */
	(data_obj *) NULL,		/* M-C-F */
	(data_obj *) NULL,		/* M-C-G */
	(data_obj *) NULL,		/* M-C-H */
	(data_obj *) NULL,		/* M-C-I */
	(data_obj *) NULL,		/* M-C-J */
	(data_obj *) NULL,		/* M-C-K */
	(data_obj *) NULL,		/* M-C-L */
	(data_obj *) NULL,		/* M-C-M */
	(data_obj *) NULL,		/* M-C-N */
	(data_obj *) NULL,		/* M-C-O */
	(data_obj *) NULL,		/* M-C-P */
	(data_obj *) NULL,		/* M-C-Q */
	(data_obj *) NULL,		/* M-C-R */
	(data_obj *) NULL,		/* M-C-S */
	(data_obj *) NULL,		/* M-C-T */
	(data_obj *) NULL,		/* M-C-U */
	(data_obj *) NULL,		/* M-C-V */
	(data_obj *) NULL,		/* M-C-W */
	(data_obj *) NULL,		/* M-C-X */
	(data_obj *) NULL,		/* M-C-Y */
	(data_obj *) NULL,		/* M-C-Z */
	(data_obj *) NULL,		/* M-ESC */
	(data_obj *) NULL,		/* M-C-\ */
	(data_obj *) NULL,		/* M-C-] */
	(data_obj *) NULL,		/* M-C-^ */
	(data_obj *) NULL,		/* M-C-_ */
	(data_obj *) NULL,		/* M-  */
	(data_obj *) NULL,		/* M-! */
	(data_obj *) NULL,		/* M-" */
	(data_obj *) NULL,		/* M-# */
	(data_obj *) NULL,		/* M-$ */
	(data_obj *) NULL,		/* M-% */
	(data_obj *) NULL,		/* M-& */
	(data_obj *) NULL,		/* M-' */
	(data_obj *) NULL,		/* M-( */
	(data_obj *) NULL,		/* M-) */
	(data_obj *) NULL,		/* M-* */
	(data_obj *) NULL,		/* M-+ */
	(data_obj *) NULL,		/* M-, */
	(data_obj *) NULL,		/* M-- */
	(data_obj *) NULL,		/* M-. */
	(data_obj *) NULL,		/* M-/ */
	(data_obj *) NULL,		/* M-0 */
	(data_obj *) NULL,		/* M-1 */
	(data_obj *) NULL,		/* M-2 */
	(data_obj *) NULL,		/* M-3 */
	(data_obj *) NULL,		/* M-4 */
	(data_obj *) NULL,		/* M-5 */
	(data_obj *) NULL,		/* M-6 */
	(data_obj *) NULL,		/* M-7 */
	(data_obj *) NULL,		/* M-8 */
	(data_obj *) NULL,		/* M-9 */
	(data_obj *) NULL,		/* M-: */
	(data_obj *) NULL,		/* M-; */
	(data_obj *) NULL,		/* M-< */
	(data_obj *) NULL,		/* M-= */
	(data_obj *) NULL,		/* M-> */
	(data_obj *) NULL,		/* M-? */
	(data_obj *) NULL,		/* M-@ */
	(data_obj *) NULL,		/* M-A */
	(data_obj *) NULL,		/* M-B */
	(data_obj *) NULL,		/* M-C */
	(data_obj *) NULL,		/* M-D */
	(data_obj *) NULL,		/* M-E */
	(data_obj *) NULL,		/* M-F */
	(data_obj *) NULL,		/* M-G */
	(data_obj *) NULL,		/* M-H */
	(data_obj *) NULL,		/* M-I */
	(data_obj *) NULL,		/* M-J */
	(data_obj *) NULL,		/* M-K */
	(data_obj *) NULL,		/* M-L */
	(data_obj *) NULL,		/* M-M */
	(data_obj *) NULL,		/* M-N */
	(data_obj *) NULL,		/* M-O */
	(data_obj *) NULL,		/* M-P */
	(data_obj *) NULL,		/* M-Q */
	(data_obj *) NULL,		/* M-R */
	(data_obj *) NULL,		/* M-S */
	(data_obj *) NULL,		/* M-T */
	(data_obj *) NULL,		/* M-U */
	(data_obj *) NULL,		/* M-V */
	(data_obj *) NULL,		/* M-W */
	(data_obj *) NULL,		/* M-X */
	(data_obj *) NULL,		/* M-Y */
	(data_obj *) NULL,		/* M-Z */
	(data_obj *) NULL,		/* M-[ */
	(data_obj *) NULL,		/* M-\ */
	(data_obj *) NULL,		/* M-] */
	(data_obj *) NULL,		/* M-^ */
	(data_obj *) NULL,		/* M-_ */
	(data_obj *) NULL,		/* M-` */
	(data_obj *) NULL,		/* M-a */
	(data_obj *) NULL,		/* M-b */
	(data_obj *) NULL,		/* M-c */
	(data_obj *) NULL,		/* M-d */
	(data_obj *) NULL,		/* M-e */
	(data_obj *) NULL,		/* M-f */
	(data_obj *) NULL,		/* M-g */
	(data_obj *) NULL,		/* M-h */
	(data_obj *) NULL,		/* M-i */
	(data_obj *) NULL,		/* M-j */
	(data_obj *) NULL,		/* M-k */
	(data_obj *) NULL,		/* M-l */
	(data_obj *) NULL,		/* M-m */
	(data_obj *) NULL,		/* M-n */
	(data_obj *) NULL,		/* M-o */
	(data_obj *) NULL,		/* M-p */
	(data_obj *) NULL,		/* M-q */
	(data_obj *) NULL,		/* M-r */
	(data_obj *) NULL,		/* M-s */
	(data_obj *) NULL,		/* M-t */
	(data_obj *) NULL,		/* M-u */
	(data_obj *) NULL,		/* M-v */
	(data_obj *) NULL,		/* M-w */
	(data_obj *) NULL,		/* M-x */
	(data_obj *) NULL,		/* M-y */
	(data_obj *) NULL,		/* M-z */
	(data_obj *) NULL,		/* M-{ */
	(data_obj *) NULL,		/* M-| */
	(data_obj *) NULL,		/* M-} */
	(data_obj *) NULL,		/* M-~ */
	(data_obj *) NULL,		/* M-^? */
};
#endif /* IBMPC */
